Xerces-C++ 3.2.4

List of all members
XMLPlatformUtils Class Reference

Utilities that must be implemented in a platform-specific way. More...

`#include <xercesc/util/PlatformUtils.hpp>`

## Static Public Member Functions
Initialization and Panic methods
static void | Initialize (const char *const locale=XMLUni::fgXercescDefaultLocale, const char *const nlsHome=0, PanicHandler *const panicHandler=0, MemoryManager *const memoryManager=0)
| Perform per-process parser initialization. More...
static void | Initialize (XMLSize_t initialDOMHeapAllocSize, XMLSize_t maxDOMHeapAllocSize, XMLSize_t maxDOMSubAllocationSize, const char *const locale=XMLUni::fgXercescDefaultLocale, const char *const nlsHome=0, PanicHandler *const panicHandler=0, MemoryManager *const memoryManager=0)
| Perform per-process parser initialization. More...
static void | Terminate ()
| Perform per-process parser termination. More...
static void | panic (const PanicHandler::PanicReasons reason)
| The panic mechanism. More...
File Methods
static XMLFileMgr * | makeFileMgr (MemoryManager *const manager)
| Make a new file object appropriate for the platform. More...
static XMLFilePos | curFilePos (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Get the current file position. More...
static void | closeFile (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Closes the file handle. More...
static XMLFilePos | fileSize (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Returns the file size. More...
static FileHandle | openFile (const char *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens the file. More...
static FileHandle | openFile (const XMLCh *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens a named file. More...
static FileHandle | openFileToWrite (const char *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Open a named file to write. More...
static FileHandle | openFileToWrite (const XMLCh *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Open a named file to write. More...
static FileHandle | openStdInHandle (MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens the standard input as a file. More...
static XMLSize_t | readFileBuffer (FileHandle theFile, const XMLSize_t toRead, XMLByte *const toFill, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Reads the file buffer. More...
static void | writeBufferToFile (FileHandle const theFile, XMLSize_t toWrite, const XMLByte *const toFlush, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Writes the buffer to the file. More...
static void | resetFile (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Resets the file handle. More...
File System Methods
static XMLCh * | getFullPath (const XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Gets the full path from a relative path. More...
static XMLCh * | getCurrentDirectory (MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Gets the current working directory. More...
static bool | isAnySlash (XMLCh c)
| Check if a character is a slash. More...
static void | removeDotSlash (XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Remove occurrences of the pair of dot slash. More...
static void | removeDotDotSlash (XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Remove occurrences of the dot dot slash. More...
static bool | isRelative (const XMLCh *const toCheck, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Determines if a path is relative or absolute. More...
static XMLCh * | weavePaths (const XMLCh *const basePath, const XMLCh *const relativePath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Utility to join two paths. More...
Timing Methods
static unsigned long | getCurrentMillis ()
| Gets the system time in milliseconds. More...
Mutex Methods
static XMLMutexMgr * | makeMutexMgr (MemoryManager *const manager)
| Factory method for creating MutexMgr object. More...
static void | closeMutex (void *const mtxHandle, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Closes a mutex handle. More...
static void | lockMutex (void *const mtxHandle)
| Locks a mutex handle. More...
static void * | makeMutex (MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Make a new mutex. More...
static void | unlockMutex (void *const mtxHandle)
| Unlocks a mutex. More...
External Message Support
static XMLMsgLoader * | loadMsgSet (const XMLCh *const msgDomain)
| Loads the message set from among the available domains. More...
NEL Character Handling <br>
static void | recognizeNEL (bool state, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| This function enables the recognition of NEL(0x85) char and LSEP (0x2028) as newline chars which is disabled by default. More...
static bool | isNELRecognized ()
| Return the value of fgNEL flag. More...

## Static Public Attributes
Public Static Data
static XMLNetAccessor * | fgNetAccessor
| The network accessor. More...
static XMLTransService * | fgTransService
| The transcoding service. More...
static PanicHandler * | fgUserPanicHandler
| The Panic Handler. More...
static PanicHandler * | fgDefaultPanicHandler
| The Panic Handler. More...
static MemoryManager * | fgMemoryManager
| The configurable memory manager. More...
static XMLFileMgr * | fgFileMgr
static XMLMutexMgr * | fgMutexMgr
static XMLMutex * | fgAtomicMutex
| Global mutex for fast or infrequent operations. More...
static bool | fgXMLChBigEndian
static bool | fgSSE2ok

## Strict IANA Encoding Checking
static void | strictIANAEncoding (const bool state)
| This function enables/disables strict IANA encoding names checking. More...
static bool | isStrictIANAEncoding ()
| Returns whether a strict IANA encoding name check is enabled or disabled. More...
static XMLSize_t | alignPointerForNewBlockAllocation (XMLSize_t ptrSize)
| Aligns the specified pointer per platform block allocation requirements. More...

## Detailed Description

Utilities that must be implemented in a platform-specific way.

This class contains methods that must be implemented in a platform specific manner. The actual implementations of these methods are available in the per-platform files inside `src/util/Platforms` .

## Member Function Documentation

## ◆ alignPointerForNewBlockAllocation()

static XMLSize_t XMLPlatformUtils::alignPointerForNewBlockAllocation | ( | XMLSize_t | ptrSize | ) |
| static

Aligns the specified pointer per platform block allocation requirements.

The results of this function may be altered by defining XML_PLATFORM_NEW_BLOCK_ALIGNMENT.

## ◆ closeFile()

static void XMLPlatformUtils::closeFile | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Closes the file handle.

This must be implemented by the per-platform driver, which should use local file services to close the passed file handle, and to destroy the passed file handle and any allocated data or system resources it contains.

Parameters

  theFile | The file handle to close
  manager | The MemoryManager to use to allocate objects

## ◆ closeMutex()

static void XMLPlatformUtils::closeMutex | ( | void *const | mtxHandle,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Closes a mutex handle.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Parameters

  mtxHandle | The mutex handle that you want to close
  manager | The MemoryManager used to allocate the object

## ◆ curFilePos()

static XMLFilePos XMLPlatformUtils::curFilePos | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Get the current file position.

This must be implemented by the per-platform driver, which should use local file services to determine the current position within the passed file.

Since the file API provided here only reads, if the host platform supports separate read/write positions, only the read position is of any interest, and hence should be the one returned.

Parameters

  theFile | The file handle
  manager | The MemoryManager to use to allocate objects

## ◆ fileSize()

static XMLFilePos XMLPlatformUtils::fileSize | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Returns the file size.

This must be implemented by the per-platform driver, which should use local file services to determine the current size of the file represented by the passed handle.

Parameters

  theFile | The file handle whose size you want
  manager | The MemoryManager to use to allocate objects

Returns
  Returns the size of the file in bytes

## ◆ getCurrentDirectory()

static XMLCh * XMLPlatformUtils::getCurrentDirectory | ( | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager` | ) |
| static

Gets the current working directory.

This must be implemented by the per-platform driver. It returns the current working directory is.

Parameters

  manager | The MemoryManager to use to allocate objects

Returns
  Returns the current working directory. This is dyanmically allocated and must be deleted by the caller when its no longer needed! The memory returned will be allocated using the static memory manager, if users do not supply a memory manager. Users then need to make sure to use either the default or user specific memory manager to deallocate the memory.

## ◆ getCurrentMillis()

static unsigned long XMLPlatformUtils::getCurrentMillis | ( |  | ) |
| static

Gets the system time in milliseconds.

This must be implemented by the per-platform driver, which should use local services to return the current value of a running millisecond timer. Note that the value returned is only as accurate as the millisecond time of the underlying host system.

Returns
  Returns the system time as an unsigned long

## ◆ getFullPath()

static XMLCh * XMLPlatformUtils::getFullPath | ( | const XMLCh *const | srcPath,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Gets the full path from a relative path.

This must be implemented by the per-platform driver. It should complete a relative path using the 'current directory', or whatever the local equivalent of a current directory is. If the passed source path is actually fully qualified, then a straight copy of it will be returned.

Parameters

  srcPath | The path of the file for which you want the full path
  manager | Pointer to the memory manager to be used to allocate objects.

Returns
  Returns the fully qualified path of the file name including the file name. This is dyanmically allocated and must be deleted by the caller when its no longer needed! The memory returned will beallocated using the static memory manager, if user do not supply a memory manager. Users then need to make sure to use either the default or user specific memory manager to deallocate the memory.

## ◆ Initialize() [1/2]

static void XMLPlatformUtils::Initialize | ( | const char *const | locale = `XMLUni::fgXercescDefaultLocale`,
|  | const char *const | nlsHome = `0`,
|  | PanicHandler *const | panicHandler = `0`,
|  | MemoryManager *const | memoryManager = `0`
| ) |  |
| static

Perform per-process parser initialization.

Initialization must be called first in any client code.

Parameters

  locale | The locale to use for messages.

The locale is set iff the Initialize() is invoked for the very first time, to ensure that each and every message loader, in the process space, share the same locale.

All subsequent invocations of Initialize(), with a different locale, have no effect on the message loaders, either instantiated, or to be instantiated.

To set to a different locale, client application needs to Terminate() (or multiple Terminate() in the case where multiple Initialize() have been invoked before), followed by Initialize(new_locale).

The default locale is "en_US".

Parameters

  nlsHome | User specified location where MsgLoader retrieves error message files. the discussion above with regard to locale, applies to nlsHome as well.
  panicHandler | Application's panic handler, application owns this handler. Application shall make sure that the plugged panic handler persists through the call to XMLPlatformUtils::Terminate().
  memoryManager | Plugged-in memory manager which is owned by the application. Applications must make sure that the plugged-in memory manager persist through the call to XMLPlatformUtils::Terminate()

## ◆ Initialize() [2/2]

static void XMLPlatformUtils::Initialize | ( | XMLSize_t | initialDOMHeapAllocSize,
|  | XMLSize_t | maxDOMHeapAllocSize,
|  | XMLSize_t | maxDOMSubAllocationSize,
|  | const char *const | locale = `XMLUni::fgXercescDefaultLocale`,
|  | const char *const | nlsHome = `0`,
|  | PanicHandler *const | panicHandler = `0`,
|  | MemoryManager *const | memoryManager = `0`
| ) |  |
| static

Perform per-process parser initialization.

Initialization must be called first in any client code.

Parameters

  initialDOMHeapAllocSize | The size of the first memory block allocated by the DOMDocument heap. Note that changing this parameter may result in poor performance and/or excessive memory usage. For the default value refer to dom/impl/DOMDocumentImpl.cpp.
  maxDOMHeapAllocSize | The maximum size of the memory block allocated by the DOMDocument heap. As the document grows, the allocated by the heap memory blocks grow from initialDOMHeapAllocSize to maxDOMHeapAllocSize. Note that changing this parameter may result in poor performance and/or excessive memory usage. For the default value refer to dom/impl/DOMDocumentImpl.cpp.
  maxDOMSubAllocationSize | The maximum size of the memory block requested that is handled by the DOMDocument heap. A request for a larger block is handled directly by the memory manager. Note that changing this parameter may result in poor performance and/or excessive memory usage. For the default value refer to dom/impl/DOMDocumentImpl.cpp.
  locale | The locale to use for messages.

The locale is set iff the Initialize() is invoked for the very first time, to ensure that each and every message loader, in the process space, share the same locale.

All subsequent invocations of Initialize(), with a different locale, have no effect on the message loaders, either instantiated, or to be instantiated.

To set to a different locale, client application needs to Terminate() (or multiple Terminate() in the case where multiple Initialize() have been invoked before), followed by Initialize(new_locale).

The default locale is "en_US".

Parameters

  nlsHome | User specified location where MsgLoader retrieves error message files. the discussion above with regard to locale, applies to nlsHome as well.
  panicHandler | Application's panic handler, application owns this handler. Application shall make sure that the plugged panic handler persists through the call to XMLPlatformUtils::Terminate().
  memoryManager | Plugged-in memory manager which is owned by the application. Applications must make sure that the plugged-in memory manager persist through the call to XMLPlatformUtils::Terminate()

## ◆ isAnySlash()

static bool XMLPlatformUtils::isAnySlash | ( | XMLCh | c | ) |
| static

Check if a character is a slash.

This must be implemented by the per-platform driver.

Parameters

  c | the character to be examined

Returns
  true if the character examined is a slash false otherwise

## ◆ isNELRecognized()

static bool XMLPlatformUtils::isNELRecognized | ( |  | ) |
| static

Return the value of fgNEL flag.

## ◆ isRelative()

static bool XMLPlatformUtils::isRelative | ( | const XMLCh *const | toCheck,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Determines if a path is relative or absolute.

This must be implemented by the per-platform driver, which should determine whether the passed path is relative or not. The concept of relative and absolute might be... well relative on different platforms. But, as long as the determination is made consistently and in coordination with the weavePaths() method, it should work for any platform.

Parameters

  toCheck | The file name which you want to check
  manager | The MemoryManager to use to allocate objects

Returns
  Returns true if the filename appears to be relative

## ◆ isStrictIANAEncoding()

static bool XMLPlatformUtils::isStrictIANAEncoding | ( |  | ) |
| static

Returns whether a strict IANA encoding name check is enabled or disabled.

## ◆ loadMsgSet()

static XMLMsgLoader * XMLPlatformUtils::loadMsgSet | ( | const XMLCh *const | msgDomain | ) |
| static

Loads the message set from among the available domains.

The returned object must be dynamically allocated and the caller becomes responsible for cleaning it up.

Parameters

  msgDomain | The message domain which you want to load

## ◆ lockMutex()

static void XMLPlatformUtils::lockMutex | ( | void *const | mtxHandle | ) |
| static

Locks a mutex handle.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Parameters

  mtxHandle | The mutex handle that you want to lock

## ◆ makeFileMgr()

static XMLFileMgr * XMLPlatformUtils::makeFileMgr | ( | MemoryManager *const | manager | ) |
| static

Make a new file object appropriate for the platform.

Parameters

  manager | The MemoryManager to use to allocate objects

## ◆ makeMutex()

static void * XMLPlatformUtils::makeMutex | ( | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager` | ) |
| static

Make a new mutex.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is. The returned handle pointer will be eventually passed to closeMutex() which is also implemented by the platform driver.

Parameters

  manager | The MemoryManager to use to allocate objects

## ◆ makeMutexMgr()

static XMLMutexMgr * XMLPlatformUtils::makeMutexMgr | ( | MemoryManager *const | manager | ) |
| static

Factory method for creating MutexMgr object.

This factory method creates a mutexmgr that will be used on the particular platform.

Parameters

  manager | The MemoryManager to use to allocate objects

## ◆ openFile() [1/2]

static FileHandle XMLPlatformUtils::openFile | ( | const char *const | fileName,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Opens the file.

This must be implemented by the per-platform driver, which should use local file services to open passed file. If it fails, a null handle pointer should be returned.

Parameters

  fileName | The string containing the name of the file
  manager | The MemoryManager to use to allocate objects

Returns
  The file handle of the opened file

## ◆ openFile() [2/2]

static FileHandle XMLPlatformUtils::openFile | ( | const XMLCh *const | fileName,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Opens a named file.

This must be implemented by the per-platform driver, which should use local file services to open the passed file. If it fails, a null handle pointer should be returned.

Parameters

  fileName | The string containing the name of the file
  manager | The MemoryManager to use to allocate objects

Returns
  The file handle of the opened file

## ◆ openFileToWrite() [1/2]

static FileHandle XMLPlatformUtils::openFileToWrite | ( | const char *const | fileName,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Open a named file to write.

This must be implemented by the per-platform driver, which should use local file services to open passed file. If it fails, a null handle pointer should be returned.

Parameters

  fileName | The string containing the name of the file
  manager | The MemoryManager to use to allocate objects

Returns
  The file handle of the opened file

## ◆ openFileToWrite() [2/2]

static FileHandle XMLPlatformUtils::openFileToWrite | ( | const XMLCh *const | fileName,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Open a named file to write.

This must be implemented by the per-platform driver, which should use local file services to open the passed file. If it fails, a null handle pointer should be returned.

Parameters

  fileName | The string containing the name of the file
  manager | The MemoryManager to use to allocate objects

Returns
  The file handle of the opened file

## ◆ openStdInHandle()

static FileHandle XMLPlatformUtils::openStdInHandle | ( | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager` | ) |
| static

Opens the standard input as a file.

This must be implemented by the per-platform driver, which should use local file services to open a handle to the standard input. It should be a copy of the standard input handle, since it will be closed later!

Parameters

  manager | The MemoryManager to use to allocate objects

Returns
  The file handle of the standard input stream

## ◆ panic()

static void XMLPlatformUtils::panic | ( | const PanicHandler::PanicReasons | reason | ) |
| static

The panic mechanism.

If, during initialization, we cannot even get far enough along to get transcoding up or get message loading working, we call this method.

Each platform can implement it however they want. This method will delegate the panic handling to a user specified panic handler or in the absence of it, the default panic handler.

In case the default panic handler does not support a particular platform, the platform specific panic handling shall be implemented here

.

Parameters

  reason | The enumeration that defines the cause of the failure

## ◆ readFileBuffer()

static XMLSize_t XMLPlatformUtils::readFileBuffer | ( | FileHandle | theFile,
|  | const XMLSize_t | toRead,
|  | XMLByte *const | toFill,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Reads the file buffer.

This must be implemented by the per-platform driver, which should use local file services to read up to 'toRead' bytes of data from the passed file, and return those bytes in the 'toFill' buffer. It is not an error not to read the requested number of bytes. When the end of file is reached, zero should be returned.

Parameters

  theFile | The file handle to be read from.
  toRead | The maximum number of byte to read from the current position
  toFill | The byte buffer to fill
  manager | The MemoryManager to use to allocate objects

Returns
  Returns the number of bytes read from the stream or file

## ◆ recognizeNEL()

static void XMLPlatformUtils::recognizeNEL | ( | bool | state,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

This function enables the recognition of NEL(0x85) char and LSEP (0x2028) as newline chars which is disabled by default.

It is only called once per process. Once it is set, any subsequent calls will result in exception being thrown.

Note: 1. Turning this option on will make the parser non compliant to XML 1.0.

1. This option has no effect to document conforming to XML 1.1 compliant, which always recognize these two chars (0x85 and 0x2028) as newline characters.

## ◆ removeDotDotSlash()

static void XMLPlatformUtils::removeDotDotSlash | ( | XMLCh *const | srcPath,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Remove occurrences of the dot dot slash.

To remove the sequence, slash dot dot slash and its preceding path segment if and only if the preceding path segment is not slash dot dot slash.

Parameters

  srcPath | The path for which you want to remove the slash dot dot slash sequence and its preceding path segment.
  manager | The MemoryManager to use to allocate objects

Returns

## ◆ removeDotSlash()

static void XMLPlatformUtils::removeDotSlash | ( | XMLCh *const | srcPath,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Remove occurrences of the pair of dot slash.

To remove the sequence, dot slash if it is part of the sequence, slash dot slash.

Parameters

  srcPath | The path for which you want to remove the dot slash sequence.
  manager | The MemoryManager to use to allocate objects

Returns

## ◆ resetFile()

static void XMLPlatformUtils::resetFile | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Resets the file handle.

This must be implemented by the per-platform driver which will use local file services to reset the file position to the start of the the file.

Parameters

  theFile | The file handle that you want to reset
  manager | The MemoryManager to use to allocate objects

## ◆ strictIANAEncoding()

static void XMLPlatformUtils::strictIANAEncoding | ( | const bool | state | ) |
| static

This function enables/disables strict IANA encoding names checking.

The strict checking is disabled by default.

Parameters

  state | If true, a strict IANA encoding name check is performed, otherwise, no checking.

## ◆ Terminate()

static void XMLPlatformUtils::Terminate | ( |  | ) |
| static

Perform per-process parser termination.

The termination call is currently optional, to aid those dynamically loading the parser to clean up before exit, or to avoid spurious reports from leak detectors.

## ◆ unlockMutex()

static void XMLPlatformUtils::unlockMutex | ( | void *const | mtxHandle | ) |
| static

Unlocks a mutex.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Note that, since the underlying system synchronization services are used, Xerces cannot guarantee that lock/unlock operations are correctly enforced on a per-thread basis or that incorrect nesting of lock/unlock operations will be caught.

Parameters

  mtxHandle | The mutex handle that you want to unlock

## ◆ weavePaths()

static XMLCh * XMLPlatformUtils::weavePaths | ( | const XMLCh *const | basePath,
|  | const XMLCh *const | relativePath,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Utility to join two paths.

This must be implemented by the per-platform driver, and should weave the relative path part together with the base part and return a new path that represents this combination.

If the relative part turns out to be fully qualified, it will be returned as is. If it is not, then it will be woven onto the passed base path, by removing one path component for each leading "../" (or whatever is the equivalent in the local system) in the relative path.

Parameters

  basePath | The string containing the base path
  relativePath | The string containing the relative path
  manager | The MemoryManager to use to allocate objects

Returns
  Returns a string containing the 'woven' path. It should be dynamically allocated and becomes the responsibility of the caller to delete.

## ◆ writeBufferToFile()

static void XMLPlatformUtils::writeBufferToFile | ( | FileHandle const | theFile,
|  | XMLSize_t | toWrite,
|  | const XMLByte *const | toFlush,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`
| ) |  |
| static

Writes the buffer to the file.

This must be implemented by the per-platform driver, which should use local file services to write up to 'toWrite' bytes of data to the passed file. Unless exception raised by local file services, 'toWrite' bytes of data is to be written to the passed file.

Parameters

  theFile | The file handle to be written to.
  toWrite | The maximum number of byte to write from the current position
  toFlush | The byte buffer to flush
  manager | The MemoryManager to use to allocate objects

Returns
  void

## Member Data Documentation

## ◆ fgAtomicMutex

XMLMutex* XMLPlatformUtils::fgAtomicMutex
| static

Global mutex for fast or infrequent operations.

Use this mutex only for fast (e.g., increment an integer, check flag, etc.) or infrequent (e.g., once-off initialization) operations.

## ◆ fgDefaultPanicHandler

PanicHandler* XMLPlatformUtils::fgDefaultPanicHandler
| static

The Panic Handler.

This is the default panic handler.

## ◆ fgFileMgr

XMLFileMgr* XMLPlatformUtils::fgFileMgr
| static

## ◆ fgMemoryManager

MemoryManager* XMLPlatformUtils::fgMemoryManager
| static

The configurable memory manager.

This is the pluggable memory manager. If it is not provided by an application, a default implementation is used.

## ◆ fgMutexMgr

XMLMutexMgr* XMLPlatformUtils::fgMutexMgr
| static

## ◆ fgNetAccessor

XMLNetAccessor* XMLPlatformUtils::fgNetAccessor
| static

The network accessor.

This is provided by the per-platform driver, so each platform can choose what actual implementation it wants to use. The object must be dynamically allocated.

Note that you may optionally, if your platform driver does not install a network accessor, set it manually from your client code after calling Initialize(). This works because this object is not required during initialization, and only comes into play during actual XML parsing.

## ◆ fgSSE2ok

bool XMLPlatformUtils::fgSSE2ok
| static

## ◆ fgTransService

XMLTransService* XMLPlatformUtils::fgTransService
| static

The transcoding service.

This is provided by the per platform driver, so each platform can choose what implementation it wants to use. When the platform independent initialization code needs to get a transcoding service object, it will call `makeTransService()` to ask the per-platform code to create one. Only one transcoding service object is requested per-process, so it is shared and synchronized among parser instances within that process.

## ◆ fgUserPanicHandler

PanicHandler* XMLPlatformUtils::fgUserPanicHandler
| static

The Panic Handler.

This is the application provided panic handler.

## ◆ fgXMLChBigEndian

bool XMLPlatformUtils::fgXMLChBigEndian
| static

The documentation for this class was generated from the following file:

- PlatformUtils.hpp